package edu.upvehu.gbg.clientserver;

import java.io.*;
 import java.net.*;

 public class ThreadedServer {
   public static void main(String[] args)throws IOException{
    ServerSocket ss=new ServerSocket(args.length==0?8080:Integer.parseInt(args[0]));
    System.out.println("====\nServidor en marcha\n"+ss+"\n====");
     do {
       Socket s=ss.accept();
       new ThreadedSocket(s);
     } while (true);
   }
 }

 class ThreadedSocket extends Thread {
   Socket s;
   ThreadedSocket(Socket s){super(); this.s=s; start();}
   @Override
   public void run() {
       System.out.println("***Conexion con el cliente establecida mediante el socket: "+s);

     try{
       InputStream is=s.getInputStream();
       OutputStream os=s.getOutputStream();

       ObjectOutputStream oos=new ObjectOutputStream(os);
       Protocolo p=new Protocolo();
       p.msg="Conectado al Servidor. "+s;
       oos.writeObject(p);

       ObjectInputStream ois=new ObjectInputStream(new BufferedInputStream(is));

       do{
           p=(Protocolo)ois.readObject();
           System.out.println(s.getPort()+"> "+p);   
           if (p.msg.equals("exit")) break;
           p.msg="Aquí el servidor. Has enviado: "+p;
           oos.writeObject(p);
       } while(true) ;
       System.out.printf("%d> ***Conexión cerrada***\n",s.getPort());
       s.close();
     } catch (IOException | ClassNotFoundException e) {
         e.printStackTrace();
     }
   }
 }
